package voip;
import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.TargetDataLine;

public class Capture extends Thread {

	protected boolean vive;
	DatagramSocket conexao;
	DatagramPacket pacote;
	InetAddress IP;
	int bufferSize;

	public Capture(DatagramSocket conexao, InetAddress IP, int bufferSize) {
		this.conexao = conexao;
		this.IP = IP;


		this.bufferSize = bufferSize;
	}

	private void captureAudio() throws SocketException {
		try {
			AudioFormat format = getFormat();
			DataLine.Info info = new DataLine.Info(TargetDataLine.class, format);
			TargetDataLine line = (TargetDataLine) AudioSystem
					.getLine(info);
			line.open(format);
			line.start();

			byte data[];
			byte header[] = new byte[4];
			byte header2[] = new byte[8];

			vive = true;
			try {
				while (vive) {
					data = new byte[bufferSize+12];
					int count = line.read(data, 12, bufferSize);

					header = ByteOp.intToByte(count);
					data[0] = header[0];
					data[1] = header[1];
					data[2] = header[2];
					data[3] = header[3];
					

					if (count > 0) {
						header2 = ByteOp
								.longToBytes(System.currentTimeMillis());
						// System.out.println(seqNum+ " "+
						// ByteOp.byteArrayToInt(header2));
						data[4] = header2[0];
						data[5] = header2[1];
						data[6] = header2[2];
						data[7] = header2[3];
						data[8] = header2[4];
						data[9] = header2[5];
						data[10] = header2[6];
						data[11] = header2[7];
						
						pacote = new DatagramPacket(data, data.length,
								IP, conexao.getLocalPort());
						conexao.send(pacote);

					}
				}
				line.close();

			} catch (IOException e) {
				System.err.println("I/O problems: " + e);
				System.exit(-1);
			}

		} catch (LineUnavailableException e) {
			System.err.println("Line unavailable: " + e);
			System.exit(-2);
		}
	}

	private AudioFormat getFormat() {
			AudioFormat derp = new AudioFormat(8000, 16, 1, true, true);
			
//			AudioFormat derp = new AudioFormat(AudioFormat.Encoding.PCM_SIGNED, 8000, 8, 1, 1, 8000, false);
			return derp;

		}


	@Override
	public void run() {
		try {
			this.captureAudio();
		} catch (SocketException e) {
			e.printStackTrace();
		}

	}

	public void kill() {
		this.vive = false;
	}

}
